package com.elab.spring.anno;

import com.elab.log.asepct.LogResponseBodyAdvice;
import com.elab.spring.config.RmqConfiguration;
import com.elab.spring.config.SpringMvcConfig;
import com.elab.spring.config.SwaggerConfigBean;
import com.elab.spring.config.ThreadConfiguration;
import com.elab.spring.exception.CommonException;
import org.springframework.context.annotation.Import;

import java.lang.annotation.*;

/**
 * @Module 注解
 * @Description 开启Spring内部主要功能
 * @Author liukaixiong
 * @Date 2020/12/4 10:42
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
@Documented
//, SpringCommonConfig.class 有问题
@Import({RmqConfiguration.class,ThreadConfiguration.class, LogResponseBodyAdvice.class, CommonException.class, SwaggerConfigBean.class, SpringMvcConfig.class})
public @interface EnableElabSpring {

}
